/* Time-stamp: <Wed Dec 05 2007 14:57:09 Stardate: [-29]8612.90 hwloidl>
   $Id$

   Build basic blocks (BBs) out of statments of the intermediate code (Chapter 8.2)
   Adapted from on-line version by A. Appel.
*/


import java.util.LinkedList;

public class BasicBlocks {
  public LinkedList<Stm> getBlocks(){ return currBlock; }

  public LinkedList<LinkedList<Stm>> blocks;
  public Label done;
  private int count = 0; // no of BBs

  //private LinkedList<LinkedList<Stm>> lastBlock;
  // list of statements in the current BB
  private LinkedList<Stm> currBlock;

  private void addStm(Stm s) { // add stm to the end of the current BB
    currBlock.addLast(s);
  }

  // complete the current basic block, stored in this.currBlock
  private void doCurrBlock(LinkedList<Stm> l) {
    if (l==null || l.size()==0){
      doCurrBlock(Utils.cons((Stm)new JUMP(done), null));
    } else {
      PPIntm pp_intm = new PPIntm();
      Stm x = Utils.head(l);
      LinkedList<Stm> xs = Utils.tail(l);
      // System.out.println("++ doCurrBlock: " + (new Integer(l.size())).toString() + " elems in list; now doing Stm " + pp_intm.visit(x));
      if (x instanceof JUMP || x instanceof CJUMP) { // end of BB
	addStm(x);
	blocks.addLast(this.currBlock);    // add completed block to overall list
        // System.out.println("++ doCurrBlock: completed block no. " + (new Integer(count)).toString());
	mkBlocks(xs);                      // break rest of the code into blocks
      } else if (x instanceof LABEL) {
	doCurrBlock(Utils.cons(new JUMP(((LABEL)x).label), l));
      } else {
	addStm(x);
	doCurrBlock(xs);
      }
    }
  }


  // take code l and break it into a list of blocks
  void mkBlocks(LinkedList<Stm> l) {
     if (l==null || l.size()==0){
       return;
     } else {
	Stm x = Utils.head(l);
	LinkedList<Stm> xs = Utils.tail(l);
	if (x instanceof LABEL) { // start of a new BB -> doCurrBlock
	  currBlock = new LinkedList<Stm>();
	  currBlock.addFirst(x);
// 	  if (blocks == null) { // first block-> need to init this.blocks
// 	    count++;
// 	    blocks = new LinkedList<LinkedList<Stm>>(); 
// 	    blocks.addLast(currBlock);
// 	  } else {
// 	    blocks.addLast(currBlock);
// 	  }
	  count++;
          // System.out.println("++ mkBlocks: block no. " + (new Integer(count)).toString() + " started with label " + ((LABEL)x).label);
	  doCurrBlock(xs);
	} else { // otw insert a  fresh label
	  mkBlocks(Utils.cons(new LABEL(new Label()), l));
	}
     }
  }

  public BasicBlocks(LinkedList<Stm> ss) {
    blocks = new LinkedList<LinkedList<Stm>>(); 
    done = new Label();
    mkBlocks(ss);
  }

}
